#pragma once

// our float type is float32:
using FLOAT = float;

// clocks:
constexpr uint32 MAIN_CLOCK 	= 125 * 1000000;
constexpr uint32 XY2_DATA_CLOCK	= 100 * 1000;
//constexpr uint32 XY2_CLOCK  	= 2 * 20 * XY2_DATA_CLOCK;


// LEDs:
constexpr uint LED_PIN  = 25;	// on-board LED
constexpr uint LED_BEAT = 18;	// heart beat
constexpr uint LED_IDLE = 19;	// idle indicator
constexpr uint LED_BUSY = 20;	// busy indicator
constexpr uint LED_ERROR = 21;	// error happened


// XY2 data lines:
constexpr uint PIN_XY2_CLOCK      = 8;
constexpr uint PIN_XY2_CLOCK_NEG  = PIN_XY2_CLOCK + 1;
constexpr uint PIN_XY2_SYNC       = PIN_XY2_CLOCK + 2;
constexpr uint PIN_XY2_SYNC_NEG   = PIN_XY2_CLOCK + 3;

constexpr uint PIN_XY2_Y        = 12;
constexpr uint PIN_XY2_Y_NEG    = PIN_XY2_Y + 1;

constexpr uint PIN_XY2_X        = 14;
constexpr uint PIN_XY2_X_NEG    = PIN_XY2_X + 1;

constexpr uint PIN_XY2_SYNC_XY  = 17; // 30 or 31 geht nicht
constexpr uint PIN_XY2_LASER	= 22; // laser on/off


// PIO settings:
#define   PIO_XY pio0
//constexpr uint SM_XY2_LASER = 0;
//constexpr uint SM_XY2_CLOCK = 1;
//constexpr uint SM_XY2_X = 2;
//constexpr uint SM_XY2_Y = 3;


// Scanner data:
constexpr uint SCANNER_MAX_SWIVELS  = 15000/120;	// data sheet: 15m/s @ 12cm

constexpr uint32 SCANNER_MIN		= 0u;
constexpr uint32 SCANNER_MAX		= 0xffffu;
constexpr uint32 SCANNER_WIDTH   	= 0x10000u;
constexpr uint32 SCANNER_MAX_STEP	= SCANNER_MAX_SWIVELS * SCANNER_WIDTH / XY2_DATA_CLOCK;


// Laser settings
constexpr uint LASER_ON_DELAY = 10;	// how many steps before switching laser ON
constexpr uint LASER_OFF_DELAY = 10;	// how many steps before switching laser OFF
constexpr uint LASER_JUMP_DELAY = 5;	// after jump


#define XY2_IMPLEMENT_ANALOGUE_CLOCK_DEMO
#define XY2_IMPLEMENT_CHECKER_BOARD_DEMO
#define XY2_IMPLEMENT_LISSAJOUS_DEMO
